/*##### rrtextplus.js, installed  by ###TextPlus Charts, by Robin Richmond*/
// Functions common to the Text+ Ancestor and Descendant chart programs

/////////////////////////////////////////////////////////////////////
////////////// document(ready) ////////////////////
$(function() {
	$('.linktoleaves').click(function () {
		$('.leaflink').first().focus();
		return false;
	});

	//Apply style rules to footer box elements
	$('#rrtpSummaryBanner').addClass('fieldnameback fieldname');
	$('#rrtpSummaryText').addClass('databack');

	//Copy the footer's contents to the floating footer.
	$('#rrtpSummaryText').html($('.tpchart footer').html());

	//Click event for the floating footer close button
	$('#rrtpFloatingSummary .rrtpCloseX').click(function() {
		$('#rrtpFloatingSummary').hide();
	});
	//Click event for the footer "top" button
	$('.rrtpLinkToTop').click(function() {
		$('#a0').focus();
	});
	//We don't want the date/place fields to be active unless the subform is open
	$("#rrdpDrop input").prop('disabled',true);

	//Limit the Generations button to the number of generations in the this person's.
	//We know that we have reached the limit when the chart's leaves have no links to additional charts.
	//The Javascript variables genstodo, leaflinks, gensdone, and gensallowed have been initialized by the PHP program.
	var plusOption = '';
	if (!leaflinks)
		gensallowed = gensdone;
	else if (gensallowed < gensdone)
		gensallowed = gensdone;
	else plusOption = "<option>+++</option>";
	$('#gensallowed').val(gensallowed);

	//The generations selection box already has an option for "All"
	var genoptions = '';
	for (gg=1; gg<=gensallowed; gg++) {
		genoptions += "<option";
		if (genstodo==gg) genoptions += ' selected';
		genoptions += ">"+gg+"</option>";
	}
	if (plusOption) genoptions += plusOption;

	$('#generations').append(genoptions);
	if (gensallowed == gensdone)
		$('#generations>option').first().prop('selected',true);

	//Make sure several standard TNG page elements do not print.
	$(".menucontainer, #searchdrop, .icons-rt, #tngmenu, #pub-innermenu, #tablesubheader, #printlink").addClass('tpnoprint');
	//Don't print the Text+ formatting forms on the Format for Printing window
	$(".tpmenu").addClass('tpnoprint');

	//I hate those extra br's below the heading. Remove one of 3 consecutive br tags.
	$('form').prev('br').prev('br').prev('br').remove(); 

	$('#generations').focus();
}); //End document.ready function

/////////////////////////////////////////////////////////////////////////
//Before the program starts, the footer has never been open
var footerStatus = 'notyet';
//////////////////////////////////////////
function openFloatingFooter() {
	$('#rrtpFloatingSummary').show();
	footerStatus = 'open';
} //End function openFooter

//////////////////////////////////////////
function closeFooter() {
	$('#rrtpFloatingSummary').hide();
	footerStatus = 'closed';
} //End function closeFooter

/////////////////////////////////////////////////////////////////////
///Onclick event for the generations button that increases the number of
//options if the user has clicked on '+++'
function generationsChange() {
	var numberOfOptions = $('#generations>option').length;
	if ($('#generations>option:selected').val() == '+++') {
		var selectedElement = $('#generations>option:selected');
		var selectedIndex = $('#generations>option').index(selectedElement);
		for (g=0; g<3; g++)
			selectedElement.before("<option>" + (selectedIndex+g) + "</option>");
		$('#generations>option').eq(selectedIndex).prop('selected',true);
	} else selfSubmit();
} //end function generationsChange

/////////////////////////////////////////////////////////////////////
//OnClick event or onchange event for the Content Control fields in the Inner Menu that
//automatically submit the form.
//In the main window, submit the form, but in the Format for Printing window, do nothing.
//Only the Format for Printing window has a field with the ID 'savecookie'
function selfSubmit() {
	if (!$('#savecookie').length)
		$('#form1').submit();
} //end function selfSubmit

////////////////////////////////////////////////////////////////
//Function to open the TextPlus Help window - modeled after the help link in all Admin innermenus.
function openTextPlusHelp(filename) {
	var newwindow = window.open(filename, 'newhelpwindow', 'height=700,width=760,resizable=yes,scrollbars=yes');
	newwindow.focus();
	return false;
}//end function openTextPlusHelp

////////////////////////////////////////////////////////////////////
//Onclick function for the Clear button in the Format For Printing form.
function clearPrintFormatCookie(whichProgram) {
	//Set a cookie named tng_ancestor or tng_descend with no value and a date in the past
	var mydate = new Date("1 Jan 2000");
	mydate = mydate.toUTCString();
	document.cookie = "tng_"+whichProgram+"=;expires="+mydate;
	$('#clearcookie').hide();
} //end function clearPrintingFormatCookie

////////////////////////////////////////////////////////////////////
//Onclick function for the "Save" button in the Format For Printing form.
function savePrintFormatCookie(whichProgram) {
		var mydate = new Date("31 Dec 2037");
		mydate = mydate.toUTCString();
		var cookievalue = $('#indentation').val() + '|' + $('#fontsize').val() +
			'|'+ $('#pagewidth').val() +'|'+ $('#widthplus').val() + '|' + $('#height').val();
		document.cookie = "tng_" + whichProgram + "=" + cookievalue + ";expires=" + mydate;
	$('#clearcookie').show();
} //end function savePrintFormatCookie

//////////////////////////////////////////////////////////
//Function to pop up a form for date and place options
//The hint text and the title of the popup box are stored in hidden divs.
//The hintname is either "ancestor" or "descend"
function showDatePlaceForm() {
	var title = $('#dateplacetitle').html();
	var content = $('#dateplaceform').html();
	$('#dateplaceform').remove();
	new LITBox(content,{type:'alert', width:550, height:300, title:title, overlay:false});
	return false;
} //End function showDatePlaceForm

///////////////////////////////////////////////////////////
//Onclick handler for 'Show marriage data' in the date/place popup.
//It hides/disables 'Where to show ancestor marriage data'
$(function() {
	dpSetAncestorMarriage();
});
function dpSetAncestorMarriage() {
	if ($("input[name='dpShowMarriage']").is(':checked')) {
		$("input[name='dpAncestorMarriage']").prop('disabled',false);
		$("#dpAncestorMarriage").removeClass('rrtpdisabled');
	} else {
		$("input[name='dpAncestorMarriage']").prop('disabled',true);
		$("#dpAncestorMarriage").addClass('rrtpdisabled');
	}
} //end function dpSetAncestorMarriage

//////////////////////////////////////////////////
//Onclick handler for the "Show Place" and "Show birth/death/marriage on separate lines".
//"Same birth/death place format" is disabled if "Show Place"  is unset or if 
//"Show birth/death/marriage on separate lines" is set
$(function() {dpSameDateFormat();});
function dpSameDateFormat() {
	if ($("input[name='dp3Lines']").is(':checked') || !$("input[name='dpPlace']").is(':checked')) {
		$("#dpSamePlace input").prop('disabled',true);
		$("#dpSamePlace>td").addClass('rrtpdisabled');
	} else {
		$("#dpSamePlace input").prop('disabled',false);
		$("#dpSamePlace>td").removeClass('rrtpdisabled');
	}
} //end function dpSameDateFormat

////////////////////////////////////////////////////////////////////
//Onclick function 
function clearDatePlaceCookie(whichProgram) {
	//Set a cookie named tng_ancestor or tng_descend with no value and a date in the past
	var mydate = new Date("1 Jan 2000");
	mydate = mydate.toUTCString();
	document.cookie = "tng_"+whichProgram+"DatePlace=;expires="+mydate;
	$('#cleardateplacecookie').hide();
} //end function clearDatePlaceCookie

////////////////////////////////////////////////////////////////////
//Onclick function for the "Save" button in the Format For Printing form.
function saveDatePlaceCookie(whichProgram) {
		var mydate = new Date("31 Dec 2037");
		mydate = mydate.toUTCString();
		var cookievalue = $('#indentation').val() + '|' + $('#fontsize').val() +
			'|'+ $('#pagewidth').val() +'|'+ $('#widthplus').val() + '|' + $('#height').val();
		document.cookie = "tng_" + whichProgram + "DatePlace=" + 
			calculateDatePlaceFieldValue(whichProgram) + ";expires=" + mydate;
	$('#cleardateplacecookie').show();
} //end function saveDatePlaceCookie

//////////////////////////////////////////////////
//Function called by the saveDatePlaceCookie and DatePlaceButton functions to
//consolidate all of the date/place options into one value.
//Each option contributes one character to the consolidated value. 
function calculateDatePlaceFieldValue() {
	var fieldValue = '';
	fieldValue += $("input[name='dpDate']:checked").val();
	fieldValue += $("input[name='dpPlace']").is(':checked')? '1' : '0';
	fieldValue += $("input[name='dp3Lines']").is(':checked')? '1' : '0';
	fieldValue += $("input[name='dpSamePlace']:checked").val();
	fieldValue += $("input[name='dpAge']").is(':checked')? '1' : '0';
	fieldValue += $("input[name='dpShowMarriage']").is(':checked')? '1' : '0';
	if ($("input[name='dpAncestorMarriage']").length)
		fieldValue += $("input[name='dpAncestorMarriage']:checked").val();
	return fieldValue;
} //end function calculateDatePlaceFieldValue

/////////////////////////////////////////////////////////////////
//Submit button in the Date/Place popup form.
//We don't want the date/place fields to clutter up the querystring, so,
//before we submit the form, their values are compressed into one value 
//in the field dpoptions, and they are all disabled.
function submitDatePlaceSubform() {
	$('#dpoptions').val(calculateDatePlaceFieldValue());
	$("#rrdpDrop input").prop('disabled',true);
	$('#form1').submit();
	return false;
} //end function submitDatePlaceSubform

/////////////////////////////////////////////////////////////////
//All fields in the subform form are disabled and their values compressed into
//one hidden field, and the parent form is submitted
function openDatePlaceSubform() {
	$('#rrdpDrop').slideDown(200);
	$("#rrdpDrop input").prop('disabled',false);
	return false;
} //end function openDatePlaceSubform

/////////////////////////////////////////////////////////////////
//All fields in the subform form are disabled and their values compressed into
//one hidden field, and the parent form is submitted
function closeDatePlaceSubform() {
	$('#rrdpDrop').slideUp(200);
	$("#rrdpDrop input").prop('disabled',true);
	return false;
} //end function closeDatePlaceSubform

/////////////////////////////////////////////////////////////////
//The "Dates & Places" dropdown button can either open or close the date/place subform
function toggleDatePlaceSubform() {
	if ($('#rrdpDrop').css('display') == 'none')
		return openDatePlaceSubform();
	else return closeDatePlaceSubform();
} //end function toggleDatePlaceSubform
