<?php
##### rrtextplus_help.php, installed by ###TextPlus Charts, by Robin Richmond
$imagepath = "textplus/"; #path to images and/or file prefix
$tngModNames['TextPlus Charts']['textplus_help.php'] = '17'; #Register this mod
###########################################################

include("../../helplib.php");
echo help_header("Help: TextPlus Charts");
?>
<style>
  h2 {margin-top:0;}
  .topmargin {margin-top:1ex;}
  .nobottom {margin-bottom:0;}
  .notop {margin-top:0;}
  div.p {margin:1ex 0;} /* Suppresses vertical spacing from embedded lists */
  div.p * {margin-top:0; margin-bottom:0;}
  ol.p>li {margin-top:1ex;} /* Each list item is spaced like a paragraph */
  .nobold {font-weight:normal;} /* For use in headings */
  .noh2 {font-weight:normal; font-size:65%;} /* Allow normal text in H2 headings */
  .hilite {color:brown;}
  /* Table of contents */
  .toc li{font-weight:bold;}
  .toc a{text-decoration:none;}
  .toc a:hover{text-decoration:underline;}
</style>
<script>
///////////////////////////////////////////////////
//Javascript function to open an image file in a second pop-up window.
function openHelpImage(filename, width, height) {
	if (!width) width='770';
	if (!height) height='550';
	var newwindow = window.open(filename, 'image', 'height='+height+',width='+width+',resizable=yes,scrollbars=yes');
	return false;
} //end function openHelpImage
</script>

<table id='top' width="100%" border="0" cellpadding="10" cellspacing="2" class="tblback normal">
<tr class="fieldnameback">
	<td class="tngshadow">
		<span class="largeheader">Help: Text+ Ancestor Chart </span>
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow" id='overview'>
		<div class='toc'>
		<h3>Table Of Contents</h3>
		<ol type='I'>
			<li><a href='#overview'>The Text+ Ancestor Chart</a></li>
			<li><a href='#printing'>Printing a Text+ Chart</a></li>
			<li><a href='#navigate'>Navigating the Family Tree</a></li>
			<li><a href='#boundary'>Boundary Conditions</a></li>
		</ol>
		</div>
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow" id='overview'>
		<h2>Overview</h2>
		<p>The Text+ Ancestor Chart is <i>similar</i> to a standard pedigree chart
		in that it draws lines up and to the right for fathers and down and to the right for mothers,
		but it is quite different in overall structure.
		Rather than place each generation in what amounts to a column in the chart,
		</p>
		<div class='p'>
		<b>It is very important that you be aware that, unlike essentially every web page you have seen,
		the Text+ Charts do not automatically wrap to the browser's (or to a printed page's) width.</b>
		The vertical lines at the left side of the page interfere with that wrapping.
		That is, if long lines in the chart wrap to the far left rather than to the indentation level on which
		the line started,
		<ul>
		<li>You <i>may</i> select formatting options that change the chart's contents, font size, and indentation,</li>
		<li>You <i>must</i> select a chart width that matches the browser or printer window, and</li>
		<li>You <i>may</i> fine-tune that width.</li>
		</ul>
		See the <a href="#printing">printing instructions</a> below.
		</div>
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">
		<div class='p'>
		<h3>Elements that are distinctive to the Text+ Ancestor Chart</h3>
		<img src="<?php echo $imagepath; ?>ancestor_example.jpg">
		<p><a href="ancestor_example.jpg" onclick="return openHelpImage('<?php echo $imagepath; ?>ancestor_example.jpg',740,650);">(Open this screen clip in a separate window)</a><p>
		</div>
		<h4>Controls and Legend</h4>
		<ol class='p'>
		<li>Controls that affect the presence of information in the chart.
			Each of these controls generates a new chart as soon as you change the control value;
			there is no Submit button.
			<ol type='a'>
			<li><b>Generations</b>
				This dropdown box determines how many generations will be included in the report.
				One of the choices is "all".</li>
			<li><b>Siblings</b>.
				When this option is checked, the siblings of the starting person, and of each ancestor, are included in the chart. That is, Aunts and Uncles are shown in each generation, providing a richer view of the database.</li>
			<li><b>Generation #s</b>
				When this option is checked, Generation numbers are placed immediately before each name in the chart./li>
				(<a href="ancestor_gencount.jpg" onclick="document.getElementById('gencount').style.display='block';return false;">See an example</a>)
				<img src="<?php echo $imagepath; ?>ancestor_gencount.jpg" id="gencount" style='display:none;'></li>
			<li><b>Sibling #s</b>.
				This option is available only if the Generation#s <i>and</i> Siblings options are both checked. When this option is checked,
				a sibling count is displayed along with the generation count in front of each name.
				(<a href="ancestor_sibcount.jpg" onclick="document.getElementById('sibcount').style.display='block';return false;">See an example</a>)
				<img src="<?php echo $imagepath; ?>ancestor_sibcount.jpg" id="sibcount" style='display:none;'></li>
			<li><b>Compact Format</b>.
				The Text+ Ancestry Chart normally adds vertical whitespace to improve its readability.  That whitespace is removed when this option is checked.</li>
			<li><b>Focus on Generation</b>.
				When a non-zero value is selected in this drop-down box, all of the names (but not the birth/death/marriage data) for people in that generation are highlighted in englarged text. This highlighting helps the user find people from a given generation.
				<p>Generation 1 - the starting person at the root of the tree - is highlighted when the page loads. The value 'none' in the selection list disables highlighting.</p>
				<p>Be careful about leaving the highlighting in effect when you print the chart.
					The enlarged letters are not taken into account by the program's text-wrapping algorithm,
					and highlighted lines might wrap prematurely.</p>
				(<a href="ancestr_focus.jpg" onclick="document.getElementById('focus').style.display='block';return false;">See an example</a>)
				<img src="<?php echo $imagepath; ?>ancestor_focus.jpg" id='focus' style='display:none;'></li>
				</li>
			</ol></li>
		<li>The "Width" control affects, well, the width of the chart,
			and is one of the chart program's provisions for handling page width and wrapping.
			By decreasing the Width, or expanding the width of your web browser window,
			you can reduce the occurrence of lines wrapping all the way to the left margin of the chart.</li>
		<li>These three icons <i>can</i> appear next to the name of every person in the chart.
			(Their presence is configurable by a site administrator, so you may not always see all three.)
			<p>The "Locate Person in Chart" icon pops up a little ancestor chart that
				focuses on the relationship between the starting person to the selected person.
				It would not be useful if you were looking at the screen clip above, because both people are visible.
				It becomes useful when you have scrolled down so that the starting person is not visible.
				(<a href="ancestr_locate.jpg" onclick="document.getElementById('locate').style.display='block';return false;">See an example</a>)
				<img src="<?php echo $imagepath; ?>ancestor_locate.jpg" id='locate' style='display:none;'></p>
			</li>
		</ol>
		<h4>Chart Elements</h4>
		(The items that start with an asterisk are configurable by a website administrator, and thus might not be visible to you.) 
		<ol start='4'>
		<li>Here you see generation 1 highlighted.</li>
		<li>Two aspects of the chart are illustrated here.
			<ol type='i'>
			<li>The data for Jacob Armay Keebler and Jacob Armay Keebler II (along with most of the other people in chart) wrap to a second line
				Though the effect is not illustrated in this screen clip, if wrapped text folds all the way to the left margin, instead of to the point where the first line started, then you need to adjust
				<ul><li>the font size, indentation, or width of the chart, or,</li>
				<li>If you are looking at the the "main" window instead of the pop-up Format for Printing window,
					you may be able to simply adjust the width of your browser window.</li>
				</ul></li>
			<li>The arrow (=>) indicates that Jacob Armay Keebler has ancestors who are not shown in this chart.</li>
			</ol></li>
		<li>At the very bottom of the chart is a footer that summarizes the report.
			(Depending on site configuration, there may also be a <i>floating</i> footer that
			stays at the bottom of your display screen.)
			Of particular note in the footer is the label '# of family lines that end in each generation'.
			This information is quite cryptic, but it is clarified when you hover over a pair of number, as shown in the screen clip above.
			</ul>
		</ol>
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow" id='printing'>
		<h2>II. Printing a TextPlus Chart</h3>
		Because of the line-wrapping limitations mentioned above,
		it is frequently necessary to go through a Format for Printing process to adjust the chart to fit a printed page.
		(<a href="ancestor_printmenu.jpg" onclick="document.getElementById('locate').style.display='block';return false;">See an clip of the Format for Printing window, with the Format for Printing controls.</a>)
			<img src="<?php echo $imagepath; ?>ancestor_printmenu.jpg" id='locate' style='display:none;'>
		This process is the same for Ancestor and Descendant Text+ charts,
		and is described <a href='rrtextplus_print_help'>a separate help page</a>.
	</td>
</tr>
<tr class="databack" id='navigate'>
	<td class="tngshadow">
		<div style="float:right"><a href="#top">Table of Contents</a></div>
		<h2>III. Navigating the Family Tree</h2>
		(That is, following links in the Text+ Charts.)
		<ol>
		<li>The names in the Text+ charts are hyperlinks to that person's profile.</li>
		<li>After each name (depending on your site configuration),
			icons link to an ancestor and a descendant chart for each person.</li>
		<li>Also, at the ends of lines of data where it is relevant,
			the character string <b>=></b> forms a hyperlink to <i>that person's</i> Text+ Ancestor Chart.</li>
		</ol>
		<p>
		These links (other than the end-of-line links) are not in the black and white Format for Printing window.
		You must use the "main" window (with your template colors) to navigate within the family tree,
		and then use the Format for Printing window just to set up the printer settings.
		</p>
		<p><a href='#'>Table of Contents</a></p>
	</td>
</tr>
<tr class="databack" id='boundary'>
	<td class="tngshadow">
		<div style="float:right"><a href="#top">Table of Contents</a></div>
		<h2>IV. Boundary Conditions</h2>
		(What happens as the number of generations grows and the vertical lines approach the right margin.)
		<p>
		There is no specific limit to the number of generations you can <em>try to</em> print with any given set of parameters,
		though things will start to break down as the vertical lines drawn by the programs approach the right margin.
		Specifically:
		<ol>
		<li>The last generation or two that fits on a line will be wrapped in a small-enough area to make each person's data take several lines to print.
		<li>A person's name is never wrapped, so there is not room on a line for the entire name, the name will wrap to the far-left margin when you print.</li>
		<li>If there are fewer than nine available spaces for data on a line, an error message will be displayed indicating that the data will not fit on the chart with the current print parameters.</li>
		</ol>
		<p>
		If any of these conditions occur, you can simply decrease the indentation or font size, or increase the page width.
		(Or, of course, decrease the number of generations.)</p>
		<p><a href='#'>Table of Contents</a></p>
	</td>
</tr>

</table>
</body>
</html>
