<?php
##### rrtextplus_help.php, installed by ###TextPlus Charts, by Robin Richmond
$imagepath = "textplus/"; #path to images and/or file prefix
$tngModNames['TextPlus Charts']['textplus_help.php'] = '16'; #Register this mod

include("../../helplib.php");
echo help_header("Help: TextPlus Charts");
?>
<style>
  h2 {margin-top:0;}
  .topmargin {margin-top:1ex;}
  .nobottom {margin-bottom:0;}
  .notop {margin-top:0;}
  div.p {margin:1ex 0;} /* Suppresses vertical spacing from embedded lists */
  div.p * {margin-top:0; margin-bottom:0;}
  ol.p>li {margin-top:1ex;} /* Each list item is spaced like a paragraph */
  .nobold {font-weight:normal;} /* For use in headings */
  .noh2 {font-weight:normal; font-size:65%;} /* Allow normal text in H2 headings */
  .hilite {color:brown;}
  /* Table of contents */
  .toc li{font-weight:bold;}
  .toc a{text-decoration:none;}
  .toc a:hover{text-decoration:underline;}
</style>
<script>
///////////////////////////////////////////////////
//Javascript function to open an image file in a second pop-up window.
function openHelpImage(filename, width, height) {
	if (!width) width='770';
	if (!height) height='550';
	var newwindow = window.open(filename, 'image', 'height='+height+',width='+width+',resizable=yes,scrollbars=yes');
	return false;
} //end function openHelpImage
</script>

<table id='top' width="100%" border="0" cellpadding="10" cellspacing="2" class="tblback normal">
<tr class="fieldnameback">
	<td class="tngshadow">
		<span class="largeheader">Help: Text+ Descendant Chart </span>
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow" id='overview'>
		<div class='toc'>
		<h3>Table Of Contents</h3>
		<ol type='I'>
			<li><a href='#overview'>The Text+ Descendant Chart</a></li>
			<li><a href='#printing'>Printing a Text+ Chart</a></li>
			<li><a href='#navigate'>Navigating the Family Tree</a></li>
			<li><a href='#boundary'>Boundary Conditions</a></li>
		</ol>
		</div>
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow" id='overview'>
		<h2>Overview</h2>
		<div class='p'>The Text+ Descendant Chart should look rather familiar, because it has the same overall structure as the outline-format descendant charts produced by essentially all genealogy program. Text+ Charts are distinct</p>
		<ol><li>In that they draw lines from parents to children, and dotted lines between multiple spouses of one person,</li>
			<li>In the amount of data that they can present for each person in the chart,</li>
			<li>In the number of options they have to vary the information in the chart, and</li>
			<li>In the way that they allow users to prune branches of a descendancy tree,
				and print only selected branches.</li>
		</ol>
		</div>
		<div class='p'>
		<b>It is very important that you be aware that, unlike essentially every web page you have seen,
		the Text+ Charts do not automatically wrap to the browser's (or to a printed page's) width.</b>
		The vertical lines at the left side of the page interfere with that wrapping.
		That is, if long lines in the chart wrap to the far left rather than to the indentation level on which
		the line started,
		<ul>
		<li>You <i>may</i> select formatting options that change the chart's contents, font size, and indentation,</li>
		<li>You <i>must</i> select a chart width that matches the browser or printer window, and</li>
		<li>You <i>may</i> fine-tune that width.</li>
		</ul>
		See the <a href="#printing">printing instructions</a> below.
		</div>
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow">
		<div class='p'>
		<h3>Elements that are distinctive to the Text+ Descendant Chart</h3>
		<img src="<?php echo $imagepath; ?>descend_example.jpg">
		<p><a href="descend_example.jpg" onclick="return openHelpImage('<?php echo $imagepath; ?>descend_example.jpg',740,650);">(Open this screen clip in a separate window)</a><p>
		</div>
		<h4>Controls and Legend</h4>
		<ol class='p'>
		<li>Controls that affect the presence of information in the chart.
			<ol type='a'>
			<li><b>Hide data of living and private people</b>.
				This option is shown <b>only if the user is logged in</b>.
				The intent of this option is to allow users to print charts that can be distributed to people without accounts;
				that is, people who should not see data for living or private individuals that the chart would otherwise show.
				When this option is checked, living and private individuals are treated as though the user were not logged in,
				and are shown with the constraints defined for that specific TNG site
				(e.g. "Living" or just initials instead of the name, no dates and places...).
				<br/>This option defaults to unchecked.</li>
			<li><b>Hide <i>descendants of living</i> and private people</b>.
				The idea here is not to show multiple generations of "Living".
				If you are logged in, then this option is labeled "Hide their descendants", and is disabled unless "Hide data of living and private people" is checked.</li>
			<li><b>Generation #s</b>
				When this option is checked, generation numbers are placed immediately before each name in the chart.
				(<a href="descend_gencount.jpg" onclick="document.getElementById('gencount').style.display='block';return false;">See an example</a>)
				<img src="<?php echo $imagepath; ?>descend_gencount.jpg" id="gencount" style='display:none;'></li>
			<li><b>Sibling #s</b>
				This option is disabled unless "Generation #s" is checked.
				Then, when this option is checked,
				the generation #s are followed by the sequential count of children.
				(<a href="descend_sibcount.jpg" onclick="document.getElementById('sibcount').style.display='block';return false;">See an example</a>)
				<img src="<?php echo $imagepath; ?>descend_sibcount.jpg" id='sibcount' style='display:none;'></li>
			</ol></li>
		<li>The "Width" control affects, well, the width of the chart,
			and is one of the chart program's provisions for handling page width and wrapping.
			By decreasing the Width, or expanding the width of your web browser window,
			you can reduce the occurrence of lines wrapping all the way to the left margin of the chart.</li>
		<li>These three icons appear next to the name of every person in the chart.
			(Their presence is configurable by a site administrator, so you may not always see all three.)
			<p>The "Locate Person in Chart" icon pops up a little descendant chart that
				focuses on the relationship between the starting person to the selected person.
				It would not be useful if you were looking at the screen clip above, because both people are visible.
				It becomes useful when you have scrolled down so that the starting person is not visible.
				(<a href="descend_locate.jpg" onclick="document.getElementById('locate').style.display='block';return false;">See an example</a>)
				<img src="<?php echo $imagepath; ?>descend_locate.jpg" id='locate' style='display:none;'></p>
			</li>
		<li>This legend refers to the little plus and minus icons next to every spouse's name.
			Clicking on the icons hide and re-display branches of the tree,
			as shown in feature #5 in the screen clip above.
			<ul><li>A boxed minus sign indicates that the couple's children <i>are</i> displayed.
				Clicking the minus sign will hide those children and their descendants.</li>
			<li>A boxed plus sign indicates that the couple's children are hidden.
				Clicking the plus sign will display those children and their descendants.</li>
			</ul></li>
		</ol>
		<h4>Chart Elements</h4>
		(The items that start with an asterisk are configurable by a website administrator, and thus might not be visible to you.) 
		<ol start='5'>
		<li>This box shows 5elements of the chart
			<ol type='a'>
			<li>Boxed minus signs for Jenny GREENLEE, and later for Sarah McCutcheon, indicating that their descendants are visible.</li>
			<li>Unboxed plus signs for William White and Francis Valbert (spouses of Martha Ann Nelson),
				indicating that they have no children. (Well, at least not in my database.)</li>
			<li>A boxed plus sign for Sara A Thompson, indicating that her descendants have been hidden.</li>
			<li>A vertical line connect Jenny Greenlee and Arbuckle Nelson to each of their children, 6 of whom can be seen in this screen clip.</li>
			<li>A short dotted line connect John Morris Nelson's two wives.</li>
			</ol></li>
		<li>If a person's place of death, but the place of burial <i>is</i> known, then the place of burial is displayed - without the cemetery name.<sup>1</sup></li>
		<li><span class='hilite'>*</span>When a person was born and died in the same place, a shorthand notation displays the placename only once.
		<li>This is another aspect of the idiosyncratic way that the TextPlus chart wraps lines at the edge of the window or printed page.
			When you see data displayed all the way to the left, rather than wrapped cleanly to the same point
			as the first line of data for the person, then you need to
			<ol><li>change the page width (in the control labeled as #2 above), or</li>
			<li>Use the font size, indendation (etc.) controls on the "Format for Printing" page.</li>
			</ol></li>
		<li><span class='hilite'>*</span>At the very bottom of the chart, a footer displays the information you see here.
			But the Chart Summary you see here is a <i>floating</i> footer that hangs out at the bottom of the web browser window.
			Depending on the configuration, the floating footer may be present as soon as the page is loaded,
			it may appear only when you first hide a branch of the chart, or it may stay hidden.
			<br>In the floating footer,
			<ul>
			<li>The little up-arrow jumps to the beginning of the chart.
				If you can already see the beginning of the chart, as in this screen clip, the arrow is not useful,
				but once you get deep inside a long chart, it can be quite handy.</li>
			<li>The X closes the floating footer, but, depending on how the site you are using is configured,
				the floating footer may re-open if you click on one of the plus or minus signs that displays or hides a branch of the chart.</li>
			<li>The count of "visible links to charts that show additional descendants" results from the fact that
				the chart does not necessarily contain all generations of the starting person's descendants.
				If someone in the final generation of the chart has descendants, then an an arrow icon is displayed,
				and serves as a link to that descendant's descendants. 
				The notion of "visible" comes from the fact that some of those descendants and links may be hidden.</li>
			<li>Finally, the number of links that wrap to another line helps produce a representation of total number of lines in the chart.
				In this example, that would be 169 people minus 22 hidden people plus 12 wrapped lines = 159 lines.<sup>2</sup></li>
			</ul>
		</ol>
		Footnotes:
		<ol>
		<li>The program <i>tries to</i> hide the cemetery name,
			but not all cemeteries use the word "Cemetery" in their names,
			so a cemetery named, say "Old Hadley Burying Ground" might slip through.</li>
		<li>Why doesn't the footer just say "# of printed lines"?. Good question. It probably should.</li>
	</td>
</tr>
<tr class="databack">
	<td class="tngshadow" id='printing'>
		<div style="float:right"><a href="#top">Table of Contents</a></div>
		<h2>II. Printing Text+ Charts</h2>
		<p>Because of the line-wrapping limitations mentioned above,
		it is frequently necessary to go through a Format for Printing process to adjust the chart to fit a printed page.
		(<a href="ancestor_printmenu.jpg" onclick="document.getElementById('print').style.display='block';return false;">See an clip of the Format for Printing window, with the Format for Printing controls.</a>)
			<img src="<?php echo $imagepath; ?>descend_printmenu.jpg" id='print' style='display:none;'>
		</p>
		<p>This process is the same for Ancestor and Descendant Text+ charts,
		and is described <a href='rrtextplus_print_help'>a separate help page</a></p>.
	</td>
</tr>
<tr class="databack" id='navigate'>
	<td class="tngshadow">
		<div style="float:right"><a href="#top">Table of Contents</a></div>
		<h2>III. Navigating the Family Tree</h2>
		(That is, following links in the Text+ Charts.)
		<ol>
		<li>The names in the Text+ charts are hyperlinks to that person's profile.</li>
		<li>After each name (depending on your site configuration),
			icons link to an ancestor and a descendant chart for each person.</li>
		<li>Also, at the ends of lines of data where it is relevant,
			the character string <b>=></b> forms a hyperlink to <i>that person's</i> Text+ Ancestor Chart.</li>
		</ol>
		<p>
		These links (other than the end-of-line links) are not in the black and white Format for Printing window.
		You must use the "main" window (with your template colors) to navigate within the family tree,
		and then use the Format for Printing window just to set up the printer settings.
		</p>
		<p><a href='#'>Table of Contents</a></p>
	</td>
</tr>
<tr class="databack" id='boundary'>
	<td class="tngshadow">
		<div style="float:right"><a href="#top">Table of Contents</a></div>
		<h2>IV. Boundary Conditions</h2>
		(What happens as the number of generations grows and the vertical lines approach the right margin.)
		<p>
		There is no specific limit to the number of generations you can <em>try to</em> print with any given set of parameters,
		though things will start to break down as the vertical lines drawn by the programs approach the right margin.
		Specifically:
		<ol>
		<li>The last generation or two that fits on a line will be wrapped in a small-enough area to make each person's data take several lines to print.
		<li>A person's name is never wrapped, so there is not room on a line for the entire name, the name will wrap to the far-left margin when you print.</li>
		<li>If there are fewer than nine available spaces for data on a line, an error message will be displayed indicating that the data will not fit on the chart with the current print parameters.</li>
		</ol>
		<p>
		If any of these conditions occur, you can simply decrease the indentation or font size, or increase the page width.
		(Or, of course, decrease the number of generations.)</p>
		<p><a href='#'>Table of Contents</a></p>
	</td>
</tr>

</table>
</body>
</html>
