<?php
##### rrtextplus_ancestor_tracker_ajx.php, installed by ###TextPlus Charts, by Robin Richmond
/* This is an AJAX program that is called from the TextPlus Ancestor chart to 
generate a popup div that shows where a person fits in the chart.
Expected querystring parameters:
 $tree
 $startingpersonID
 $trail - the SOSA number of the person we are looking for,.
*/
$tngModNames['TextPlus Charts']['rrtextplus_ancestor_tracker_ajx.php'] = '17';
#######################################################################

$textpart = "pedigree";
include("tng_begin.php");
include($subroot . "pedconfig.php");
#Read custom language strings from a mods subfolder rather than from regular cust_text.php files.
$modfolder = $text['tp-modfolder'];
if (file_exists("$modspath/$modfolder/{$mylanguage}_cust_text.php"))
	include("$modspath/$modfolder/{$mylanguage}_cust_text.php");
else include("$modspath/$modfolder/languages/English_cust_text.php");

#PHP functions installed by the Text Plus Charts mod
include("{$cms['tngpath']}rrtextplus_lib.php");

$righttree = checktree($tree);

#turn the sosa number into a list of the sosa numbers for each preceding generation.
$sosaBackwards = $sosa = array();
while ($trail) {
	$sosaBackwards[] = $trail;
	$trail =floor($trail/2);
}
#Define the $sosa array with increasing generation number
for ($s=count($sosaBackwards); $s>0; $s--)
	$sosa[] = $sosaBackwards[$s-1];

#Initialize mod options and formatting parameters.
$params['charttype'] = 'ancestor';
$params['phpBaseFilename'] = 'rrtextplus_' . $params['charttype'];
$params['phpFilename'] = $params['phpBaseFilename'] . '.php';
initializeParameters($params['charttype']);
$params['siblings'] = $params['printauntsuncles'] = $params['print1stgenerationsiblings'] = 0;
$params['showgennums'] = 1;
$params['siblingnums'] = 0;
$params['compact'] = 1;


# Iterate through the trail recursively
$personresult = getPersonSimple($tree, $startingpersonID);

#Generate the chart with this recursive function
$html = getAncestryPerson($startingpersonID, $personresult, 1);

# Add chart links at the bottom of the locator chart
/*$html .= "<div><a href='desctracker.php?tree=$tree&trail=$trail'>{$text['tp-graphicalview']}</a>
	&ensp;&ensp;||&ensp;&ensp;
	<a href='rrtextplus_descend.php?personID=$thispersonID&amp;tree=$tree'
		title='{$text['descendants']}'>{$text['tp-printdesc']}</a>
	&ensp;&ensp;||&ensp;&ensp;
	<a href='rrtextplus_ancestor.php?personID=$thispersonID&amp;tree=$tree'
		title='{$text['ancestors']}'>{$text['tp-printanc']}</a>
	</div>\n";
*/

#Place the chart in a box that will be popped-up by the calling program.
#Generate the box in which the text will be placed
echo "<div id='trackdiv2'>
<div id='trackbanner'>
	<div class='rrtpBoxButton'><img src='img/tng_close.gif' class='rrtpCloseX'></div>
	<div class='rrtpBoxBanner'>$trackedpersonname</div>
</div>
<div id='tracktext' class='rrtpBoxText'>$html</div>
</div>\n";
exit;

###############################################################
################### End of Mainline Program ###################
###############################################################
# Recursive function that generates the report
function getAncestryPerson($personID, $personresult, $generation) {
	global $count, $params, $rrconfig, $vbars, $text;
	global $tree, $righttree;
	global $families_table, $children_table;
	global $sosa;

	$html = '';
	$personrow = tng_fetch_assoc($personresult);
	$vbars[$generation] = $personrow['sex']=="M" ? 0 : 1;

	$familyresult = getChildParentsFamilyMinimal($tree, $personID);
	if ($familyresult)
		$familyrow = tng_fetch_assoc($familyresult);
	else $familyrow['husband'] = $familyrow['wife'] = '';

	#Do father
	if ($generation<count($sosa) && (!($sosa[$generation] % 2))) {
		$presult = getPersonSimple($tree, $familyrow['husband']);
		$html .= getAncestryPerson($familyrow['husband'], $presult, $generation+1);
	}

	#Grab this person's name
	$srights = determineLivingPrivateRights($personrow, $righttree);
	$personrow['allow_living'] = $srights['living'];
	$personrow['allow_private'] = $srights['private'];
	$fullname = getName( $personrow );
	#This Global variable is placed in the popup heading by the mainline program
	if ($generation==count($sosa)) $GLOBALS['trackedpersonname'] = $fullname;

	#Indent as necessary.
	if ($personrow['sex'] == "M") $vbars[$generation]=3;
	else $vbars[$generation] = 2;
	$html .= getAncestryVbars($generation,"ancestor");

	$namelink = "<a href='getperson.php?personID={$personrow['personID']}&amp;tree=$tree'>$fullname</a>";

	$gennum = PrintGenerationNumbers2($generation);
	$datastr = "<span class='tpgnum g$generation'>&thinsp;$gennum</span>";

	$html .= "$datastr<span class='pdata g$generation' title='{$text['generation']}" . ($generation+1) . "'>&thinsp;$namelink</span><div>";

	#Clear the vertical bars for all generations above this one.
	for ($i=$generation+2; $i<=count($sosa); $i++)
		$vbars[$i] = 0;

	#Do mother
	if ($generation<count($sosa)  && $sosa[$generation] % 2) {
		$presult = getPersonSimple($tree, $familyrow['wife']);
		$html .= getAncestryPerson($familyrow['wife'], $presult, $generation+1);
	}
	return $html;
} #end function getAncestryPerson

######################################################################
# Return the indentation, including vbars
function getAncestryVbars($generation) {
	global $vbars, $count, $draw, $drawvbar, $params, $text;

	$indenttext = "";
	if ($generation>1) {
		#This loop prints indentation for all but the current generation.
		for ($i = 1; $i<$generation; $i++) {
			$indenttext .= "<span title='{$text['generation']} $i'>" . str_repeat("&nbsp;",$params['indentation'] - 3) . $drawvbar[$vbars[$i]] . str_repeat("&nbsp;",2) . '</span>';
		}
		$indenttext .= "<span title='{$text['generation']} $generation'>" . str_repeat("&nbsp;",$params['indentation'] - 3);
		$indenttext .= $drawvbar[$vbars[$generation]] . $draw['hbar'];
		$vbars[$generation] = $vbars[$generation]-2;
		$indenttext .= '</span>';
	} else $vbars[$generation] = 0;
	$start = "<div>";

	$html = "<div><span class='tpindents'>$indenttext</span>";
	return $html;
} #end function getAncestryVbars
?>
