<?php
##### rrtextplus_innermenuedit.php, installed by ###TextPlus Charts, by Robin Richmond
# This utility program removes or restores the old "Text" chart link in the innermenus of
# Ancestor and Descendant chart programs. Most sites that install Text+ Charts will not
# bother with this program, which is run from the Mod Manager. Those that do use it
# will probably run it once to remove the old links, and possibly once again to restore
# the old links.
#
# WHY IT EXISTS
# The Ancestor and Descendant innermenus can get crowded after mods add programs to them.
# Since the Text+ charts essentially supercede the Text charts, some site Admins who
# have installed the TextPlus mod may want to elmininate the old Text charts from the
# Ancestor and/or Descendant innermenus. But, because different mods install different
# programs, it is hard to know exactly which PHP chart program need to be modified.
# That is, Mod Manager really is up to the task, but this program is.
#
# This program
#  a. Looks for standard Ancestor and Descendant chart programs,
#  b. Checks for the presence of innermenu links to the standard Ancestor or Descendant
#     text chart program,
#  c. Determines whether the link has been commented out, and
#  d. Offers to disable or restore the link.
#  The user can specify other programs that should be processed, too.

define ("SUPPRESSION_COMMENT", '#Suppress Old Text Link# ');
define ("EMPTY_CELL", "<td class='lightback'>&nbsp;</td>");
$tngModNames['TextPlus Charts']['rrtextplus_innermenuedit.php'] = '17beta1'; #Register this mod
#######################################################################

include("begin.php");
include($cms['tngpath'] ."adminlib.php");
$textpart = "textplus";
include($cms['tngpath'] ."getlang.php");
include($cms['tngpath'] ."$mylanguage/admintext.php");
################################################
#Read custom language strings from a mod subfolder rather than from regular cust_text.php files.
$modfolder = $text['tp-modfolder'];
if (file_exists("$modspath/$modfolder/{$mylanguage}_cust_text.php"))
	include("$modspath/$modfolder/{$mylanguage}_cust_text.php");
else include("$modspath/$modfolder/languages/English_cust_text.php");

$admin_login = 1;
include($cms['tngpath'] ."checklogin.php");
include($cms['tngpath'] ."version.php");

$flags['tabs'] = $tngconfig['tabs'];
tng_adminheader( $admtext['rrbt-heading1'], $flags );

#**************** Javascript functions ****************************
echo "<script type='text/javascript'>
//Function to select or clear all checkeboxes in a column. The checkboxed in each column are flagged as
//class='disable' or class='restore'.
function toggleCheckboxes (buttonclass, setOrNot) {
	$('.'+buttonclass).prop('checked',setOrNot);
}
</script>

</head>\n";

echo "<body background='{$cms['tngpath']}img/background.gif'>\n";
$tabmenu='';
$innermenu = "<a href=\"{$_SERVER['SCRIPT_NAME']}\" class=\"lightlink\">Reload</a>";
$innermenu .= " &nbsp;|&nbsp; ...This line is part of the TNG 'Inner Menu'..";
$menu = doMenu("", "", $innermenu);
echo displayHeadline($text['tp-utility'] , "{$cms['tngpath']}img/misc_icon.gif", $menu, "");
?>

<table width="100%" border="0" cellpadding="10" cellspacing="2" class="lightback">
<tr class="databack">
<td class="tngshadow normal">
<h4>The Innermenus of some Descendant and Ancestor Chart programs (particularly Ancestor
Charts), can get awfully crowded after certain TNG mods have added links to those menus.
Since the original "Text" charts have been substantially superceded by the corresponding "TextPlus" charts,
you can shorten the Inner Menus just a little by disabling the original "Text" link.
</h4>

<?php
	#Hard-coded lists of Ancestor and Descdant chart programs
	$descendantPrograms = 'descend,descendtext,rrtextplus_descend,register,desctracker,rrcount_descendants';
	$ancestorPrograms = 'pedigree,pedigreetext,rrtextplus_ancestor,verticalchart,ahnentafel,extrastree,fan,mappedigree';
	#Add programs supplied by mod parameters.
	$otherAncestorChartPrograms = 'none'; #Mod parameter
	$otherDescendantChartPrograms = 'none'; #Mod parameter
	$notAModParameter = 'none'; #Fake mod parameter
	#Remove spaces that may have been placed between program names, and remove the
	#filename extension .php.
	if ($otherDescendantChartPrograms != 'none')
		$descendantPrograms .= ',' . str_replace(' ','', str_replace('.php', '', $otherDescendantChartPrograms));
	if ($otherAncestorChartPrograms != 'none')
		$ancestorPrograms .= ',' . str_replace(' ','', str_replace('.php', '', $otherAncestorChartPrograms));
	#Create arrays to make it easier to process the lists
	$descendantPrograms = explode(',', $descendantPrograms);
	$ancestorPrograms = explode(',', $ancestorPrograms);

	#Start by taking any action that was specified by the submit buttons, which are named 'b1'
	#The functions called here display the programs that they process, and indication what they did (or couldn't do).
	if ($b1 == $text['tp-disable']) {
		if (count($_GET['descendant']))
			disableInnermenuLinks($_GET['descendant'], 'descend');
		if (count($_GET['ancestor']))
			disableInnermenuLinks($_GET['ancestor'], 'pedigree');
	}
	elseif ($b1 == $text['tp-restore']) {
		restoreInnermenuLinks($_GET['restore'] );
	}
	# End of actions

	$checkboxcount = array('disableancestor'=>0, 'disabledescendant'=>0, 'restore'=>0);

	#This form and table list all of the standard chart programs that are hardcoded above, along with
	#- The evident number of Innermenu Links
	#- The status of the Text Chart Link
	#- Checkboxes that let the user indicate what action to take on specific programs.
	echo "<form action='' method='get' name='innermenuedit'>

	<table cellpadding='3' cellspacing='1' border='0' class='normal'>
	<thead>
		<tr class='fieldnameback' style='vertical-align:bottom'>
			<th rowspan='2' class='fieldname'>File</th>
			<th class='fieldname' rowspan='2'>Type</th>
			<th class='fieldname' rowspan='2'>Innermenu<br>Links</th>
			<th class='fieldname' rowspan='2'>Text Chart<br>Link Status</th>
			<th class='fieldname' style='text-align:center;'><input type='button' value='{$admtext['selectall']}' onClick=\"toggleCheckboxes('disable', true);\"/> <br>
				<input type='button' value='{$admtext['clearall']}' onClick=\"toggleCheckboxes('disable', false);\"/></th>
			<th class='fieldname' style='text-align:center;'><input type='button' value='{$admtext['selectall']}' onClick=\"toggleCheckboxes('restore', true);\"/> <br>
				<input type='button' value='{$admtext['clearall']}' onClick=\"toggleCheckboxes('restore', false);\"/></th>
			<th class='fieldname' rowspan='2'>Unexpected Text</th>
		</tr>
		<tr><th class='fieldname' style='text-align:center;'>{$text['tp-disable']}</th>
			<th class='fieldname' style='text-align:center;'>{$text['tp-restore']}</th></tr>
	</thead>
	<tbody>\n";

	#List the descendant programs, and then the ancestor programs.
	for ($p=0; $p<count($descendantPrograms); $p++)
		echo tableRow($descendantPrograms[$p], 'descendant');
	for ($p=0; $p<count($ancestorPrograms); $p++)
		echo tableRow($ancestorPrograms[$p], 'ancestor');
	#Add a row for the submit buttons
	echo "</tbody>
		<tr>", str_repeat("<th class='fieldname'>&nbsp;</td>", 4), "
		<td class='fieldname'><input type='submit' name='b1' value='{$text['tp-disable']}'/></td>
		<td class='fieldname'><input type='submit' name='b1' value='{$text['tp-restore']}'/></td>
		<td class='fieldname'>&nbsp;</td>
		</tr>
	</table>
	</form>\n";

	echo "<p style='font-weight:bold;'>{$admtext['rrbt-close']}</p>\n";
?>
<hr>
<style>
ol.p>li,ul.p>li {margin-top:1ex; margin-bottom:1ex;} /* Give list items paragraph spacing */
.code {background-color:linen; color:sienna; font-weight:bold;}
</style>
<b>Notes:</b>
<ol class='p'>
	<li><b>The "Inner Menu"</b> is a standard navigation menu in TNG programs.
		<ul><li>It is below the main page navigation and page heading,
			and is usually immediately below a Tab menu.</li>
			<li>It almost always has a dark background and white text.</li>
			<li>Its links are text, not buttons, and are not underlined.</li>
			<li>The links are usually separated by vertical bars.</li>
		</ul>
		In <i>this</i> program there is a contrived Inner Menu with a "Reload" link,
			and the message "...This line is part of the TNG 'Innermenu'..."</li>
	<li><b>Chart Programs installed by Mods</b>
		<ol><li>Some of the programs listed in the table above are installed by mods,
			and it is quite reasonable for them to be listed as missing. For instance,
			<ul><li>fan.php is not standard in TNGv10, and can be installed by the Fan Chart mod.</li>
				<li>mappedigree.php is installed by the Ancestor Map mod, and</li>
				<li>rrcount_descendants.php is installed by the Count Descendants mod.</li>
			</ul></li>
		<li>If you have installed mods that install <i>other</i> Ancestor or Descendant chart programs,
			you can use the mod parameters of the TextPlus Charts Mod to add those programs to the lists above.</li>
		</ol></li>
	<li><b style='color:brown;'>You should not try to Install or Uninstall any mods that add Ancestor or Descendant Chart programs <em>while the "Text" links are hidden</em></b>.
		<br>If you do so, you will probably break one mod or another.
		But if you <i>have</i> hidden some "Text" links, just use this program to restore the "Text" links before Installing or Uninstalling such a mod.
		You can then hide the "Text" links again after you have Installed or Uninstalled that mod.
		For example:
		<ul>
		<li>I'm pretty sure that if you copy one of the Maternal and Paternal chart mods to your mods folder,
			will show a "Cannot install" status if the "Text" links are hidden.</li>
		<li>Some mods will immediately show a "cannot install" status when you hide the "Text" links.</li>
		<li>The TextPlus Charts mod - and, I suspect, some others - keeps its "Installed"
			status if you hide "Text" links,
			but if you <em>Uninstall</em> the TextPlus Charts mod <em>while the "Text" links are hidden</em>,
			the mod's status will become "Cannot install" rather than "Ok to Install".</li>
		</ul>
		But in each of these cases, you should be able to fix the "Cannot install" status by using this program to restore the hidden links.</li>
	<li><b>Hiding a link by editing a PHP file</b>
		<br>As noted above, you can use the TextPlus Chart mod parameters to cause this program to (try to) hide the "Text" link in <i>other</i> Ancestor or Descendant chart programs.
		However, some programs may use unexpected HTML code, and this program may not always work.
		Even in those cases however, you should generally be able to hide any Inner Menu links easily by manually editing the program's PHP file.
		<p>
		For example, to manually remove the "Text" link from a hypothetical <i>Ancestor</i> chart called "Family History" generated by the program <code>familyhistory.php</code>:
		<ol type='a'>
			<li>Open <code>familyhistory.php</code> in a text editor such as Notepad++.</li>
			<li>The Ancestor "Text" chart is generated by the program <code>pedigreetext.php</code>, so, using the editor, you'll need to search for the base filename, "pedigreetext".
			<li>Many TNG programs use a function that looks for a file by name and stores its filename in a PHP variable. In those cases, you will likely encounter a line of PHP code that look like this:
				<div><code class='code'>$pedigreetext_url = getURL( "pedigreetext", 1 );</code></div>
				(Frankly, at a glance, this code seems kind of pointless. After all, we already know that the Ancestor "Text" program is <code>pedigreetext.php</code>, so you may wonder why we need the getURL function to find it.  There <em>is</em> a reason, but it isn't worth going into here.</li>
			<li>Keep searching for "pedigreetext"
				(or, if you found the line of code above, you could search for "pedigreetext_url")
				until you find a line of PHP code that starts like this:
					<br><code class='code'>&nbsp;&nbsp;$innermenu .= "&lt;a href=\"$pedigreetext_url...</code>, or maybe
					<br><code class='code'>&nbsp;&nbsp;$innermenu .= "&lt;a href=\"pedigreetext.php...</code>
				<br>(The hyperlinked word "Text" is buried in this line of code, obscured by TNG's language string feature.)</li>
			<li>This line of PHP code the Text chart hyperlink to the PHP variable <code>$innermenu</code>, which is later used to generate the Inner Menu.</li>
			<li>To hide the link, you can just add a PHP comment (starting with <code class='code'>//</code>) at the beginning of the line.
				Such a comment will disable the rest of the line of PHP code, and remove that particular link from the Inner Menu.
				<br>For instance, you might insert
				<code class='code'>//Disable this link</code> in front of
				<code class='code'>&nbsp;&nbsp;$innermenu .= </code>,
				either before or after the leading spaces.</li>
			<li>You have made the only edit that is necessary; You can now close the file to save the changes file.</li>
		</ol>
		<p>Note that you have not removed the PHP statement that defines the link;
		you have merely hidden it from the program
		(or, using programming jargon, you have "commented it out").
		</p>
		<p>As with program files modified by this program it is probably important that you <i>restore</i>
		the link if you need to Install or Uninstall any mod that affects the Inner Menu of the file you edited.
		</p>
		<p>To restore the link, just edit the PHP file again, and remove the comment;
				i.e. remove <code class='code'>//Disable this link</code>
		</li>
</ol>

</td>
</tr>
</table>
<?php
if (file_exists('rrshowmodnames_include.php')) include_once ('rrshowmodnames_include.php'); #List mods
?>
<?php echo "<div align=\"right\"><span class=\"normal\">$tng_title, v.$tng_version</span></div>"; ?>
</body>
</html>

<?php
##########################################################################
################## End of Mainline code; PHP Functions follow ############
##########################################################################

#### Function to display a table row for one Ancestor or Descendant Chart program
function tableRow ($program, $programtype) {
	global $rootpath, $admtext;

	$html = "<tr><td class='lightback'>$program.php</td><td class='lightback'>$programtype</td>";
	$textchartprefix = $programtype == 'descendant' ? 'descend' : 'pedigree';

	$filespec = "$rootpath/$program.php";
	if (file_exists($filespec)) {
		$contents = file_get_contents( $filespec );
		if ($contents) {
			#Count the innermenu hyperlinks.
			$pattern = '@\$innermenu .*= "( &nbsp;&nbsp; \| &nbsp;&nbsp; )*<a href=@';
			$menuentries = preg_match_all($pattern, $contents, $matches);
			$html .= "<td class='lightback'>$menuentries </td><td class='lightback'>";
			#Look for an innermenu Text Chart hyperlink. We don't need a regular expression here.
			$pattern = '$innermenu .= "<a href=\"$' . $textchartprefix . 'text_url';
			$textchartlink = strpos($contents, $pattern);
			#if ($textchartlink !== false) {
				#Check the beginning of the line that has the Text Chart hyperlink to see if it
				#contains our disabling comment.
				$pattern = '@^\t*(.*)\$innermenu .= "<a href=\\\\"\$' . $textchartprefix .'text_url@m';
				if (preg_match ($pattern, $contents, $matches)) {
					# Figure out what is between the start of the line and the start of the assignment statement
					if (!$matches[1]) #Nothing between the tabs and $innermenu, so it is active
						$html .= "{$admtext['active']}</td><td class='lightback' style='text-align:center;'>" . checkbox($program, $programtype, 'disable') . "</td>" . str_repeat( EMPTY_CELL, 2);
					elseif ($matches[1] == SUPPRESSION_COMMENT)
						$html .= "{$text['tp-disabled']}</td>" . EMPTY_CELL . "<td class='lightback' style='text-align:center;'>" . checkbox($program, $programtype, 'restore') . "</td>" . EMPTY_CELL;
					elseif (strpos($matches[1], constant("SUPPRESSION_COMMENT")) !== false)
						#The comment is there, but so is something else
						$html .= "{$text['tp-other']}</td>". EMPTY_CELL ."<td class='lightback' style='text-align:center;'>" . checkbox($program, $programtype, 'restore') . "</td><td class='lightback'>{$matches[1]}</td>";
					else #Something completely unexpected is there
						$html .= "{$text['tp-other']}</td>" . str_repeat( EMPTY_CELL, 2) . "<td class='lightback'>{$matches[1]}</td>";
				}
			else # The chart link isn't there
				$html .= "<strong style='color:brown;'>{$text['tp-missing']}</strong></td>" . str_repeat( EMPTY_CELL, 3);
		} else #the program file is empty
			 $html .= "<td colspan='2' class='lightback'>{$text['tp-nofile']}</td>" .
				str_repeat( EMPTY_CELL, 3);
	} else #the program file is missing
		 $html .= "<td colspan='2' class='lightback'>{$text['tp-nofile']}</td>" .
			str_repeat( EMPTY_CELL, 3);

	 return "$html</tr>\n";
} #end function tableRow

###############################################
# Function to create a checkbox
# Parameters:
#  $program - The name of the Ancestor or descendancy program we are looking at.
#             It will be the value of the checkbox.
#  $programtype = 'Ancestor' or 'Descendant'
#  $action = 'disable' or 'restore'
function checkbox ($program, $programtype, $action) {
	global $checkboxcounts;

	#When disabling the link, we need to distinguish between Ancestor and Descendant programs,
	#but to restore the link, we don't, since all we need to know is that the suppression comment
	#is there.
	if ($action == 'disable') $checkboxname = $programtype;
	else $checkboxname = 'restore';

	#For disabling, check the boxes for Ancestor links, but not Descendant links because
	#Ancestor innermenu are much more like to be too crowded than Descendant innermenus.
	#For restoring, check all boxed, since we know it has the suppression comment.
	$checked = '';
	if ($action == 'restore' || $programtype == 'ancestor') $checked = ' checked';

	#Increment a count to make sure that the checkbox ID's are unique.
	#(However, as things stand, we don't use the IDs, so this isn't necessary.)
	$checkboxcounts[$checkboxname]++;

	$html = "<input type='checkbox' class='$action' name='{$checkboxname}[]' id='{$checkboxname}{$checkboxcounts[$checkboxname]}'
		value='$program'$checked />";
	return $html;
} #end of function checkbox

###############################################
# Disable links to a the Text version of an Ancestor or Descendant report by inserting
# a comment in front of the assignment statement that adds the link to the innermenu.
# $programlist is a vector whose values are program names
# $searchtext tells us whether the Text Chart link in that program is to the Ancestor or Descendant Text report.
function disableInnermenuLinks( $programlist, $searchtext ) {
	global $rootpath, $admtext;

	echo "<b>$searchtext</b>";
	foreach ($programlist AS $program) {
		echo "<div>$program.php: ";
		$filename = "{$rootpath}$program.php";
		$contents = file_get_contents( $filename );
		if (!$contents) echo "$filename {$text['tp-notfound']}</div>";
		else {
			$pattern = "#(^t*)(\$innermenu .= \"<a href=\\\"\${$searchtext}_url).*#";
			$pattern = '@(^\t*)(\$innermenu .= "<a href=\\\\"\$' . $searchtext .'text_url)@m';
			$newcontents = preg_replace( $pattern, '$1'. constant("SUPPRESSION_COMMENT") . '$2', $contents);
			if (!$newcontents)
				echo $text['tp-nolink'] . '</div>';
			else {
				if ($contents == $newcontents)
					echo $text['tp-nochange'] . '</div>';
				else {
					$byteswritten = file_put_contents( $filename, $newcontents);
					if ($byteswritten) echo $text['tp-linkdisabled'] . '</div>';
					else echo $text['tp-nowrite'] . '</div>';
				}
			}
		}
	}
} #end of function removeInnermenuLinks

################################################
function restoreInnermenuLinks( $programlist) {
	global $rootpath, $admtext;
	echo "<b>Restoring links</b>";
	foreach ($programlist AS $program) {
		echo "<div>$program.php: ";
		$filename = "{$rootpath}$program.php";
		$contents = file_get_contents( $filename );
		if (!$contents) echo "$filename {$text['tp-notfound']}</div>";
		else {
			$newcontents = str_replace( constant("SUPPRESSION_COMMENT"), "", $contents);
			if (!$newcontents)
				echo $text['tp-noconnent'] . '</div>';
			else {
				if ($newcontents == $contents)
					echo $text['tp-nochange'] . '</div>';
				else {
					$byteswritten = file_put_contents( $filename, $newcontents);
					if ($byteswritten) echo $text['tp-restored'] . '</div>';
					else echo $text['tp-nowrite'] . '</div>';
				}
			}
		}
	}
} #end of function restoreInnermenuLinks
?>

